#include <stdio.h>
#include <stdlib.h>
#include <math.h>

long fileSize(FILE *fp) {
  
    long start, end;
    
    fflush(fp);
    rewind(fp);
    start = ftell(fp);
    
    fseek(fp, 0L, SEEK_END);
    end = ftell(fp);
    rewind(fp);
    
    return (end - start);
    
}


void    main(int argc, char** argv)
{
	FILE    *fi, *fo;
	float   f, mse, snr;
	///char    *msg = " ", 
	char *frame_i, *frame_o;
	//, sample_i, sample_o;
	int     s1, s2;
	///int     logg = 0;
	long    k, size, number_frames, frame_size, sample_index;
	//int	verbose = 0;
	
	if (argc != 4)
        {
                printf("psnr_fast: Peak SNR (dB) between two files (1 byte/sample) (*RLQ-94*) (*741v35-10*)\n");
                printf("Usage: psnr_fast file1 file2 N\n"
                        "N is the desired number of frames to be compared\n");
                exit(1);
        }


/*	if (argc > 3)
		if (argv[3][0] == '-')
			if (argv[3][1] == 'v')
				if (argv[3][2] == '\0')
				{
					verbose = 1;
					if (argc > 4) argv[3] = argv[4];
					if (argc > 5) argv[4] = argv[5];
					argc--;
				}*/
		
	if((fi = fopen(argv[1], "rb")) == NULL)
        {
                printf("psnr_fast: Peak SNR (dB) between two files (1 byte/sample) (*RLQ-94*) (*741v35-10*)\n");
                printf("Error opening file %s\n", argv[1]);
                exit(1);
        }
        
        if ((fo = fopen(argv[2],"rb")) == NULL)
        {
                printf("psnr_fast: Peak SNR (dB) between two files (1 byte/sample) (*RLQ-94*) (*741v35-10*)\n");
                printf("Error opening file %s\n", argv[2]);
                exit(1);
        }
        
        number_frames = atoi(argv[3]);
	
	if ( ( number_frames  <= 0 )  )
        {
                printf("psnr_fast: Peak SNR (dB) between two files (1 byte/sample) (*RLQ-94*) (*741v35-10*)\n");
                printf("N should be greater than 0.\n");
                exit(1);
        }

        
	k = 0;
	mse = 0.0;
	
	size = fileSize(fi);
	
	frame_size = (long) size/number_frames;
	
	frame_i = (char *) malloc( frame_size*sizeof(char) );
	frame_o = (char *) malloc( frame_size*sizeof(char) );
	
	rewind(fi);
	rewind(fo);
	
	///fprintf(stderr,"Frames %d Frame size %d File size %d\n", number_frames, frame_size, size);
	
	while(fread(frame_i, sizeof(char), frame_size, fi))
	{
	  	
	  if(fread(frame_o, sizeof(char), frame_size, fo))
	  {
  
	    sample_index=0;
	    while(sample_index<frame_size)
	    {
	      //sample_i = *(frame_i+sample_index);
	      s1 = *(frame_i+sample_index);
	      	      
	      
	      //sample_o = *(frame_o+sample_index);
	      s2 = *(frame_o+sample_index++);
	      
	      
	      k++;
	      f = (s1>0?s1:s1+256) - (s2>0?s2:s2+256);
	      mse += f * f;
	    
	      ///if(sample_index==1)
		//fprintf(stderr,"Sample i %d Sample o %d Diff %f Mse %f\n", s1, s2, f, mse);
	      
	      //sample_index++;
	    }
	    
	  }
	  else
	  {
		printf("psnr_fast: Peak SNR (dB) between two files (1 byte/sample) (*RLQ-94*) (*741v35-10*)\n");
		printf("Unexpected end of file %s. Read %d bytes\n", argv[2],k);
		free(frame_i);
		free(frame_o);
		exit(1);
	  }
	
	}
	
	///fprintf(stderr,"Samples %d\n", k);
	
// 	while ((s1 = fgetc(fi)) != EOF)
// 	{
// 		if((s2 = fgetc(fo)) == EOF)
// 		{
// 			printf("PSNR: Peak SNR (dB) between two files (1 byte/sample) (*RLQ-94*)\n");
// 			printf("Unexpected end of file %s. Read %d bytes\n", argv[2],k);
// 			exit(1);
// 		}
// 		k++;
// 		f = s1 - s2;
// 		mse += f * f;
// 	}

	mse /= k;
	fclose(fi);
	fclose(fo);

	if (mse > 10e-20)
        {
                snr = 10.0 * log((255.0 * 255.0) / mse) / log(10.0);
                printf("%f\n", snr);
                
                
        }
        else
        {
                printf("Inf\n");
        }
        
	free(frame_i);
	free(frame_o);
}
